/**
 * Henya.java
 *
 * Copyright (c) 1997- Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.henya;

import java.applet.Applet;
import java.awt.*;

/**
 * Henya moji applet main class.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version 0.92
 */
public class Henya extends Applet implements Runnable {
  private Thread scrint = null;
  private Image buff;
  private Graphics grf;
  private Dimension wd;

  private HiraganaHandler hh;
  private Messages ms;

  private boolean loopf;

  public void init() {
    ms = new Messages(getParameter("MESSAGE"));
  }

  public void start() {
    loopf = true;
    if ( scrint != null ) {
      scrint = new Thread(this);
      scrint.start();
    }
  }

  public void stop() {
    loopf = false;
  }

  public void update(Graphics g) {
    paint(g);
  }

  public void paint(Graphics g) {
    if ( grf == null ) {
      wd = getSize();
      buff = createImage(wd.width, wd.height);
      grf = buff.getGraphics();
      hh = new HiraganaHandler(grf, wd, getParameter("LINEWIDTH"));
      if ( scrint == null ) {
        scrint = new Thread(this);
        scrint.start();
      }
    }
    g.drawImage(buff, 0, 0, this);
  }

  private int cou = -33;
  private int mi = -1;
  private int endcou,curzm;
  private int[] curMsg, curAtr;
  private int gtzm = 256;

  public void run() {
    while ( loopf && scrint.isAlive() ) {
      if ( cou < -32 ) {
        cou = 0;
        mi++; if ( mi >= ms.lastnum ) mi = 0;
        curMsg = ms.chr[mi];
        curAtr = ms.atr[mi];
        curzm = ms.zm[mi];
        endcou = ms.pl[mi];
      }

      if ( cou < 0 ) {
        hh.setStr(curMsg, curAtr,
          (gtzm*(-cou)+curzm*(32+cou))/32, (32+cou)*curzm/32,33-(32+cou));
        cou--;
      } else if ( cou < 32 ) {
        hh.setStr(curMsg, curAtr,
          (gtzm*(32-cou)+curzm*cou)/32, cou*curzm/32,33-cou);
        cou++;
      } else {
        cou++;
      }

      if ( cou >= endcou ) {
        cou = -1;
        if ( endcou > 128 ) gtzm = 256;
        else gtzm = 32;
      }
      hh.move();
      repaint();
      try {
        Thread.sleep(33);
      } catch (InterruptedException e){}
    }
  }
}
