/**
 * HnLine.java
 *
 * Copyright (c) 1997- Kenta Cho. All rights reserved.
 */
package jp.gr.java_conf.abagames.henya;

import java.awt.*;
import java.util.Random;

/**
 * Draw thick line.
 *
 * @author cs8k-cyu@asahi-net.or.jp
 * @version 0.92
 */
public class HnLine {
  private Graphics grf;
  public int[] xa = new int[16];
  public int[] ya = new int[16];
  public int cou;

  private static Random rnd = new Random();
  public int rw = 2;

  private static int linewidth = 3;

  public HnLine(Graphics g) {
    grf = g;
    cou = -1;
  }

  public static void setLineWidth(int lw) {
    linewidth=lw;
  }

  public void dLine(int x1, int y1, int x2, int y2) {
    int i;
    grf.drawLine(x1, y1, x2, y2);
    if ( Math.abs(x1-x2)>Math.abs(y1-y2) ) {
      for ( i=1 ; i<linewidth ; i++ ) {
        grf.drawLine(x1, y1+i, x2, y2+i);
      }
    } else {
      for ( i=1 ; i<linewidth ; i++ ) {
        grf.drawLine(x1+i, y1, x2+i, y2);
      }
    }
  }

  public void move() {
    if ( cou < 0 ) return;
    int i=0;
    int x1, y1, x2, y2, xc, yc;
    x1 = xa[i]+rnd.nextInt()%rw;
    y1 = ya[i]+rnd.nextInt()%rw;
    while ( xa[i+1] != -32760 ) {
      x2 = xa[i+1]+rnd.nextInt()%rw;
      y2 = ya[i+1]+rnd.nextInt()%rw;
      xc = (x1+x2)/2+rnd.nextInt()%rw;
      yc = (y1+y2)/2+rnd.nextInt()%rw;
      dLine(x1,y1,xc,yc);
      dLine(x2,y2,xc,yc);
      i++;
      x1 = x2; y1 = y2;
    }
  }
}
